--=|Select Full Class Names for a Creation Code.|=--

         SELECT wk_components.name || '.' || class_name AS full_name
           FROM 
             ( SELECT wk_classes.name AS class_name, 
		              wk_classes.wk_components_fk 
		       FROM   wk_classes 
		       WHERE  wk_classes.wk_creation_codes_fk = ':|Creation Code|:'
             ) AS T
     INNER JOIN wk_components
             ON wk_components.id = T.wk_components_fk
       ORDER BY full_name
;

--=|Find all full class names for a given class name.|=--

         SELECT wk_components.name || '.' || class_name AS full_name
           FROM 
             ( SELECT wk_classes.name AS class_name, 
		              wk_classes.wk_components_fk 
		       FROM   wk_classes 
		       WHERE  wk_classes.name = ':|Class Name|:'
             ) AS C
     INNER JOIN wk_components
             ON wk_components.id = C.wk_components_fk
       ORDER BY full_name
;


--=|Find all full member names for a given member name.|=--


         SELECT wk_components.name || '.' || 
                class_name         || '.' || 
                member_name AS full_name
           FROM
              ( SELECT wk_members.name AS member_name,
                       wk_members.wk_classes_fk
                FROM   wk_members
                WHERE  wk_members.name = ':|Member Name|:'
              ) AS M
     INNER JOIN
              ( SELECT wk_classes.id,
                       wk_classes.name AS class_name,
                       wk_classes.wk_components_fk
                FROM   wk_classes
              ) AS C
             ON C.id = M.wk_classes_fk
     INNER JOIN wk_components
             ON wk_components.id = C.wk_components_fk
       ORDER BY full_name

--=|Find all Member names for a given Class name.|=--


         SELECT wk_components.name || '.' || 
                class_name         || '.' || 
                member_name AS full_name
           FROM
              ( SELECT wk_members.name AS member_name,
                       wk_members.wk_classes_fk
                FROM   wk_members
              ) AS M
     INNER JOIN
              ( SELECT wk_classes.id,
                       wk_classes.name AS class_name,
                       wk_classes.wk_components_fk
                FROM   wk_classes
                WHERE  wk_classes.name = ':|Class Name|:'
              ) AS C
             ON C.id = M.wk_classes_fk
     INNER JOIN wk_components
             ON wk_components.id = C.wk_components_fk
       ORDER BY full_name


